



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>内功心法 -- java.util.ArrayList&lt;E&gt; (3)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">内功心法 -- java.util.ArrayList&lt;E&gt; (3)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 22:36:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>写在前面的话：读书破万卷，编码如有神</strong><br />--------------------------------------------------------------------<br />下文主要对java.util.ArrayList&lt;E&gt;的6个常用查询操作进行介绍，主要内容包括：</p>
<p>1、ArrayList查询操作</p>
<p>参考内容：</p>
<p>1、JDK源码(1.7)</p>
<p>--------------------------------------------------------------------<strong>&nbsp;</strong></p>
<p>1. ArrayList常用的6个查询操作</p>
<p>查询操作:</p>
<p>(1)&nbsp;boolean contains(Object o)</p>
<p>功能: 判断列表中是否有包含了元素o</p>
<p>示例代码:</p>
<div>
<pre class="prettyprint linenums"> public class ArrayListTest {<br />
     public static void main(String[] args) {<br />
         ArrayList&lt;Integer&gt; list = new ArrayList&lt;Integer&gt;();<br />
         list.add(0,44);<br />
         list.add(1,33);<br />
         list.add(2,22);<br />
         list.add(1,66);<br />
         list.add(4,99);<br />
         System.out.println("list :" + list);<br />
         //测试ArrayList的boolean contains(Object o)方法的使用<br />
         System.out.println("列表中是否包含了元素22 :"+list.contains(22));<br />
         System.out.println("列表中是否包含了元素34 :"+list.contains(34));<br />
         System.out.println("列表中是否包含了元素66 :"+list.contains(66));<br />
     }<br />
 }

 运行结果:<br />
 list :[44, 66, 33, 22, 99]<br />
 列表中是否包含了元素22 :true<br />
 列表中是否包含了元素34 :false<br />
 列表中是否包含了元素66 :true</pre>
</div>
<p>源代码如下:</p>
<div>
<pre class="prettyprint linenums"> public boolean contains(Object o) {<br />
         //内部是通过调用indexOf(Object o) 方法来实现的<br />
         return indexOf(o) &gt;= 0;<br />
     }</pre>
</div>
<p>(2)&nbsp;E get(int index)</p>
<p>功能: 返回列表index位置上的元素</p>
<p>示例代码:</p>
<div>
<pre class="prettyprint linenums"> public class ArrayListTest {<br />
     public static void main(String[] args) {<br />
         ArrayList&lt;Integer&gt; list = new ArrayList&lt;Integer&gt;();<br />
         list.add(0,44);<br />
         list.add(1,33);<br />
         list.add(2,22);<br />
         list.add(1,66);<br />
         list.add(4,99);<br />
         System.out.println("list :" + list);<br />
         //测试ArrayList的E get(int index)方法的使用<br />
         System.out.println("返回列表中下标索引为1的元素 :"+list.get(1));<br />
         System.out.println("返回列表中下标索引为4的元素 :"+list.get(4));<br />
         System.out.println("返回列表中下标索引为9的元素 :"+list.get(9));<br />
     }<br />
 }

 运行结果:<br />
 list :[44, 66, 33, 22, 99]<br />
 返回列表中下标索引为1的元素 :66<br />
 返回列表中下标索引为4的元素 :99<br />
 Exception in thread "main" java.lang.IndexOutOfBoundsException: Index: 9, Size: 5<br />
     at java.util.ArrayList.rangeCheck(Unknown Source)<br />
     at java.util.ArrayList.get(Unknown Source)<br />
     at ArrayListTest.main(ArrayListTest.java:16)</pre>
</div>
<p>源代码如下: 查看源码可以发现java.util.ArrayList&lt;E&gt;根据索引下标来获取元素的速度非常快。</p>
<div>
<pre class="prettyprint linenums"> public E get(int index) {<br />
         //检查index是否合法<br />
         rangeCheck(index);<br />
         //内部调用elementData(int index)方法<br />
         return elementData(index);<br />
     }

 @SuppressWarnings("unchecked")<br />
     E elementData(int index) {<br />
         return (E) elementData[index];<br />
     }</pre>
</div>
<p>(3)&nbsp;int indexOf(Object o)</p>
<p>功能: 返回元素o在列表中的索引位置</p>
<p>示例代码:</p>
<div>
<pre class="prettyprint linenums"> public class ArrayListTest {<br />
     public static void main(String[] args) {<br />
         ArrayList&lt;Integer&gt; list = new ArrayList&lt;Integer&gt;();<br />
         list.add(0,44);<br />
         list.add(1,33);<br />
         list.add(2,22);<br />
         list.add(1,66);<br />
         list.add(4,99);<br />
         System.out.println("list :" + list);<br />
         //测试ArrayList的'int indexOf(Object o)'方法的使用<br />
         System.out.println("返回列表中元素为22的索引下标 :"+list.indexOf(22));<br />
         System.out.println("返回列表中元素为66的索引下标 :"+list.indexOf(66));<br />
         System.out.println("返回列表中元素为41的索引下标 :"+list.indexOf(41));<br />
     }<br />
 }

 运行结果:<br />
 list :[44, 66, 33, 22, 99]<br />
 返回列表中元素为22的索引下标 :3<br />
 返回列表中元素为66的索引下标 :1<br />
 返回列表中元素为41的索引下标 :-1</pre>
</div>
<p>源代码如下:</p>
<div>
<pre class="prettyprint linenums">     public int indexOf(Object o) {<br />
         if (o == null) {<br />
             //元素o为null,循环列表中的元素查找<br />
             for (int i = 0; i &lt; size; i++)<br />
                 if (elementData[i]==null)<br />
                     return i;<br />
         } else {<br />
             //元素o不为null,循环列表中的元素查找<br />
             for (int i = 0; i &lt; size; i++)<br />
                 if (o.equals(elementData[i]))<br />
                     return i;<br />
         }<br />
         return -1;<br />
     }</pre>
</div>
<p>(4)&nbsp;boolean isEmpty()</p>
<p>功能: 判断列表是否为空,如果为空,返回true;如果不为空,返回false.</p>
<p>示例代码:</p>
<div>
<pre class="prettyprint linenums"> public class ArrayListTest {<br />
     public static void main(String[] args) {<br />
         ArrayList&lt;Integer&gt; list = new ArrayList&lt;Integer&gt;();<br />
         list.add(0,44);<br />
         list.add(1,33);<br />
         list.add(2,22);<br />
         list.add(1,66);<br />
         list.add(4,99);<br />
         System.out.println("list :" + list);<br />
         //测试ArrayList的' boolean isEmpty()'方法的使用<br />
         System.out.println("ArrayList列表是否为空: " + list.isEmpty());<br />
     }<br />
 }

 运行结果:<br />
 list :[44, 66, 33, 22, 99]<br />
 ArrayList列表是否为空: false</pre>
</div>
<p>源代码如下:</p>
<div>
<pre class="prettyprint linenums">     public boolean isEmpty() {<br />
         return size == 0;<br />
     }</pre>
</div>
<p>(5)&nbsp;int lastIndexOf(Object o)</p>
<p>功能: 查询元素o在列表中的索引位置(倒序查找)</p>
<p>示例代码:</p>
<div>
<pre class="prettyprint linenums"> public class ArrayListTest {<br />
     public static void main(String[] args) {<br />
         ArrayList&lt;Integer&gt; list = new ArrayList&lt;Integer&gt;();<br />
         list.add(0,44);<br />
         list.add(1,33);<br />
         list.add(2,22);<br />
         list.add(1,66);<br />
         list.add(4,99);<br />
         list.add(2,66);<br />
         list.add(1,44);<br />
         System.out.println("list :" + list);<br />
         //测试ArrayList的'int lastIndexOf(Object o)'方法的使用<br />
         System.out.println("ArrayList列表中元素33最后一次出现的索引位置: " + list.lastIndexOf(33));<br />
         System.out.println("ArrayList列表中元素66最后一次出现的索引位置: " + list.lastIndexOf(66));<br />
         System.out.println("ArrayList列表中元素55最后一次出现的索引位置: " + list.lastIndexOf(55));<br />
     }<br />
 }

 运行结果:<br />
 list :[44, 44, 66, 66, 33, 22, 99]<br />
 ArrayList列表中元素33最后一次出现的索引位置: 4<br />
 ArrayList列表中元素66最后一次出现的索引位置: 3<br />
 ArrayList列表中元素55最后一次出现的索引位置: -1</pre>
</div>
<p>源代码如下:</p>
<div>
<pre class="prettyprint linenums"> public int lastIndexOf(Object o) {<br />
         if (o == null) {<br />
             //元素o为null,利用循环倒序查找null元素<br />
             for (int i = size-1; i &gt;= 0; i--)<br />
                 if (elementData[i]==null)<br />
                     return i;<br />
         } else {<br />
             //元素o不为null,利用循环倒序查找o元素<br />
             for (int i = size-1; i &gt;= 0; i--)<br />
                 if (o.equals(elementData[i]))<br />
                     return i;<br />
         }<br />
         return -1;<br />
     }</pre>
</div>
<p>(6)&nbsp;int size()</p>
<p>功能: 返回列表中元素的个数</p>
<p>示例代码:</p>
<div>
<pre class="prettyprint linenums"> public class ArrayListTest {<br />
     public static void main(String[] args) {<br />
         ArrayList&lt;Integer&gt; list = new ArrayList&lt;Integer&gt;();<br />
         list.add(0,44);<br />
         list.add(1,33);<br />
         list.add(2,22);<br />
         list.add(1,66);<br />
         list.add(4,99);<br />
         list.add(2,66);<br />
         list.add(1,44);<br />
         System.out.println("list :" + list);<br />
         //测试ArrayList的'int size()'方法的使用<br />
         System.out.println("ArrayList列表的size为: " + list.size());<br />
     }<br />
 }

 list :[44, 44, 66, 66, 33, 22, 99]<br />
 ArrayList列表的size为: 7</pre>
</div>
<p>源代码如下:</p>
<div>
<pre class="prettyprint linenums">     public int size() {<br />
         return size;<br />
     }</pre>
</div>
<p>--------------------------------------------------------------------------</p>
<p>java.util.ArrayList系列文章</p>
<p><a href="http://www.cnblogs.com/xinhuaxuan/p/6344150.html" rel="external nofollow noreferrer">java.util.ArrayList&lt;E&gt;(1)</a>　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6351295.html" rel="external nofollow noreferrer">java.util.ArrayList&lt;E&gt;(2)</a>　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6354132.html" rel="external nofollow noreferrer">java.util.ArrayList&lt;E&gt;(3)</a></p>
<p><a href="http://www.cnblogs.com/xinhuaxuan/p/6354146.html" rel="external nofollow noreferrer">java.util.ArrayList&lt;E&gt;(4)</a>　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6354179.html" rel="external nofollow noreferrer">java.util.ArrayList&lt;E&gt;(5)</a>　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6370197.html" rel="external nofollow noreferrer">java.util.ArrayList&lt;E&gt;(6)</a></p>
<p><strong>相关知识 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;</strong></p>
<p><a href="http://www.cnblogs.com/xinhuaxuan/p/6341502.html" rel="external nofollow noreferrer">java.util.Collection&lt;E&gt;</a>&nbsp;　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6343547.html" rel="external nofollow noreferrer">java.util.AbstractCollection&lt;E&gt;</a>&nbsp;　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6341645.html" rel="external nofollow noreferrer">java.util.List&lt;E&gt;</a></p>
<p><a href="http://www.cnblogs.com/xinhuaxuan/p/6346629.html" rel="external nofollow noreferrer">java.util.AbstractList&lt;E&gt;</a>&nbsp;　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6347036.html" rel="external nofollow noreferrer">java.util.Iterator&lt;E&gt;</a>&nbsp;　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6347199.html" rel="external nofollow noreferrer">java.util.ListIterator&lt;E&gt;</a></p>
<p><a href="http://www.cnblogs.com/xinhuaxuan/p/6349165.html" rel="external nofollow noreferrer">Java中的标记接口</a>&nbsp;　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6362892.html" rel="external nofollow noreferrer">迭代器模式</a>&nbsp;　　<a href="http://www.cnblogs.com/xinhuaxuan/p/6370039.html" rel="external nofollow noreferrer">Java中的深拷贝和浅拷贝</a>&nbsp;&nbsp;<a href="http://www.cnblogs.com/xinhuaxuan/p/6372103.html" rel="external nofollow noreferrer">java.util.Arrays</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390d33n8.html">缓存依赖中cachedependency对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22wnoq.html">VS2012新建项目出错：未找到与约束ContractName Microsoft&period;VisualStudio&period;Text&period;ITextDocumentFactoryService</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gd4w8.html">go环境import cycle not allowed问题处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mldz9.html">iOS七大手势之&lpar;平移、捏合、轻扫、屏幕边缘轻扫&rpar;手势识别器方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmo4619.html">from 表单提交</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z14y1x9.html">PHP前端&dollar;&period;ajax传递数据到后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpz0e9.html">基于STM32F10x的串口&lpar;USART&rpar;输入输出编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yrp6eq.html">基于cygwin构建u-boot（二）gcc的C语言标准版本号（-std&equals;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1jpmjq.html">xml序列化和反序列化（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyywlgmq.html">HTTP Basic和Digest认证介绍与计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1mez49.html">Android使用Glide加载https链接的图片不显示的原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4mknk9.html">复制数据库的Shell命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe77d8.html">Java读取oracle数据库中blob字段数据文件保存到本地文件&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzxkj9.html">Sublime Text 许可证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpmg209.html">【转】XMPP&lowbar;3920&lowbar;最靠谱的中文翻译文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpzddz9.html">centos 快速安装wordpress</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gprl5l9.html">jmeter 常用内置变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/953lzn08.html">motion的移植和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/953ep7m8.html">G - 確率（水题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4m3mlq.html">day09&comma;10 函数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mj2748.html">uvc摄像头代码解析1</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ydprz8.html">POJ 2686 Traveling by Stagecoach</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge43678.html">Ubuntu Apache2 配置简单介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvv5pq.html">Eclipse 的 git 插件操作 &amp;quot&semi;代码提交&amp;quot&semi;以及&amp;quot&semi;代码冲突&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1447mq.html">Rest之路 -- 从第二个Rest application里面分析 Rest 方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ydn4z8.html">FZU 2110 Star</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mjy3o8.html">FTP-使用记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojv3vlq.html">IOS开发中如何判断程序第一次启动（根据判断结果决定是否显示新手操作引导）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj2g538.html">IOS开发－ObjC－NSArray</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kpyl69.html">Unity3D &mdash;&mdash;强大的跨平台3D游戏开发工具（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
